/* genoctkey.c                            */
/* generate oct-keycode table, 2006-03-16 */
/* NON COMMERCIAL USE ONLY                */

#include <stdio.h>
#include <math.h>

#define ITEM_PER_LINE 6

const char tonename[12][3] = {
  "C ", "C#", "D ", "D#", "E ", "F ",
  "F#", "G ", "G#", "A ", "A#", "B "
}; // const char tonename[][]

int main()
{
  int i;
  double s;
  int oct, key;
  printf("// MIDInote to oct-keycode table\r\xa\r\xa");
  printf("#include \"tonegen.h\"\r\xa\r\xa");
  printf("const uint8_t octkey[128] = {");
  printf("           //  MIDInote, oct:keycode");
  printf("\r\xa    ");
  for (i = 0; i < 128; i++) {
    oct = i / 12;
    key = i % 12;
    printf("0x%.2x", (oct << 4) | key);
    printf("%s", (i != 127 ? ", " : ""));
    if ((ITEM_PER_LINE-1) == (i % ITEM_PER_LINE)) {
      printf("//  %.3d..%.3d,  %.2d:%.3s..%.3s",
              i-ITEM_PER_LINE+1, i, oct, 
              tonename[key-ITEM_PER_LINE+1], 
              tonename[key]);
      printf("\r\xa    ");
    }
  }
  printf("\r\xa}; // const uint8_t octkey[]\r\xa");
  return(0);
}
