/* genportab.c,                  2006-Oct-2     */
/* portament increment table for 4-bit mantissa */
/* NON COMMERCIAL USE ONLY                      */

#include <stdio.h>
#include <math.h>

#define ITEMPERLINE 4
#define TABSIZE     128

int main()
{
  int i, hex[TABSIZE];
  double mant, pinc;
  double dt=4e-3;
  printf("//\n");
  printf("// portament increment table for delta time = %6.3f ms\n", dt*1e3);
  printf("//\n");
  printf("\n");
  printf("#include \"tonegen.h\"\n");
  printf("\n");
  printf("const uint32_t portab[%d] = {", TABSIZE);
  for (i = 0; i < 128; i++) {
    mant = dt * 12 * 16 / 0.7 * pow(2.0, -i/16.0);
    pinc = 0x10000 * mant;
    hex[i] = round(pinc);
    if (0 != i) printf("%s", ",");
    if (0 == (i % ITEMPERLINE)) printf("\n");
    printf("  0x%.6x", hex[i]);
  } // for (i = 
  printf("\n}; // const uint32_t portab[%d]\n", TABSIZE);
  return(0);
} // int main()
