/***********************************************/
/*  rx62conf.c : system configuration table    */
/***********************************************/

#include "../common/tonegen.h"

// PCLK    = 48.000 MHz

// lb_ofs  = log2(min_MIDI_freq) - log2(fs) + Q_phacc - Q_fnumber + 1
//         = 17.031360 - log2(fs)
//         = log2(t1div) - 8.485171

// oct_ofs  = floor(lb_ofs)

// note_ofs = 1536 * (lb_ofs - oct_ofs)

const sys_config_st_t sys_config[2][MAX_CONFIG] = {
//
//
 {// poly, t1div, tick1ms, tick4ms, oct_ofs, note_ofs, fs_str}
   {   13,  1000,      48,     192,       1,      738,  "48" },// fs=48.000 kHz
   {   15,  1200,      40,     160,       1,     1142,  "40" },// fs=40.000 kHz
   {   20,  1500,      32,     128,       2,      101,  "32" },// fs=32.000 kHz
   {   22,  1600,      30,     120,       2,      244,  "30" },// fs=30.000 kHz
   {   27,  2000,      24,      96,       2,      738,  "24" },// fs=24.000 kHz
 },
//
//
 {// poly, t1div, tick1ms, tick4ms, oct_ofs, note_ofs, fs_str}
   {   15,  1000,      48,     192,       1,      738,  "48" },// fs=48.000 kHz
   {   18,  1200,      40,     160,       1,     1142,  "40" },// fs=40.000 kHz
   {   24,  1500,      32,     128,       2,      101,  "32" },// fs=32.000 kHz
   {   25,  1600,      30,     120,       2,      244,  "30" },// fs=30.000 kHz
   {   32,  2000,      24,      96,       2,      738,  "24" },// fs=24.000 kHz
 }
}; // const sys_config_st_t sys_config[]
