/****************************************************/
/*                                                  */
/* eg.h : Envelope Generator define                 */
/*                                                  */
/* NON COMMERCIAL USE ONLY                          */
/*                                                  */
/* 2011/04/20 Rev. 1.01 by pcm1723 (reorganized)    */
/*                                                  */
/****************************************************/

#ifndef EG_H
#define EG_H

/* Envelope Generator table size */
#define EG_TAB_SIZE 79

#define FORCE_RELEASE_RATE (4*14)

#define EG_96dB (1UL<<26)
#define EG_48dB (1UL<<25)
#define EG_60dB (5UL<<23)

enum egmode_t {OFF, ATTACK, DECAY, SUSTAIN, RELEASE, REDAMPER, FORCE_RELEASE, FORCE_DAMP};

//
// variables
//
extern const int32_t  eg_tab[EG_TAB_SIZE];

//
// functions
//
extern int16_t eg(unit_prop_t *u_p, op_prop_t *o_p);

#endif // EG_H