/**************************************************/
/*                                                */
/* seq.c : SMAF sequencer top level               */
/*                                                */
/* NON COMMERCIAL USE ONLY                        */
/*                                                */
/* 2007/03/26 Rev. 1.00 by pcm1723                */
/*                                                */
/**************************************************/

#include "tonegen.h"

#if (defined(SEQUENCER) & !defined(USE_SMF))
void seq_songsel(int song_no)
{
  int i;
/*  
  for (i = 0; i <MAXMIDICH; i++) 
    all_note_off(&(ch_prop[i]));
*/    
  if ((song_no) >= demosongs) song_no = 0; // reset to first song
  else if (0 > song_no)       song_no = demosongs-1; // reset to last song
  demo_no = song_no;
  init_seq();
} // void songselect()

void seq_next_song(void)
{
  seq_songsel(demo_no+1);
} // void seq_next_song()

void seq(void)
{
  int i;
  if (0 == seq_duration) { // get next event
    eos = get_event(demosong[demo_no].seq);
    if (eos) {    // loop from first 
      if ((++demo_no) >= demosongs) {
        demo_no = 0; // reset to first song
        init_seq();
        demoflag = loopflag; // stop demo if not loop
        if (0 == demoflag) {
          demoflag = 1; // temporary set demoflag
          demo_off();   // demoflag cleared in demo_off()
        } // demo end
      } 
      else {
        init_seq();
      } // if ((++demo_no)
    } // if (eos)
    else seq_duration = get_dur(demosong[demo_no].seq); // get next duration
  } // if (0 == seq_duration)
  seq_tick++;
  if (SEQTICK4ms <= seq_tick) {
    seq_tick = 0;
    for (i = 0; i < MAXSEQCH; i++) {
      if (0 < seq_st[i].gatetime) {
        if (0 == (--seq_st[i].gatetime)) { // key off
           if (MAXMIDICH > i) { //
             ch_prop_t *c_p = &(ch_prop[i]);
//              unit_prop[c_p->in_use[0]].keyoff = 1;
             midi_note_off(c_p, seq_st[i].notenumber);
           } // if (MAXMIDICH > i) ...
        } // if (0 == ..
      } // if (0 > ... 
    } // for (i ... 
    seq_duration--;
  } // if (SEQTICK4ms <= ... 
} // void seq()

// Initialize sequencer 
void init_seq(void)
{ int  i, ch;
  const demo_st *dp = &(demosong[demo_no]);
  seq_tick = 0;             // reset sequencer tick
  seq_p    = 8;             // set seq data pointer (skip Mtsq chunk) 
  seq_duration = get_dur(dp->seq); // get very first duration 
  GM_system_on();
#ifdef LCD
  lcd_clear(lcd_buf2);
  lcd_buf_p = lcd_buf2; // set sub screen
  lcd_buf_w = lcd_buf_p;
/*
  for (i = 0; i < strlen(dp->title); i++) {
    if (LCD_BUFSIZE > i)  
      lcd_buf2[i++] = ((' ' > c) ? ' ' : c);
  }
*/
  lcd_putstr(dp->title);
  lcd_buf_w = lcd_buf; // restore forward screen
#endif
  for (i = 0; i < MAXSEQCH; i++) { // clear gatetime queue
    seq_st[i].gatetime = 0;
  } // for (i = 
  for (ch = 0; ch < MAXMIDICH; ch++) {
    ch_prop_t *c_p = &(ch_prop[ch]);
    all_note_off(c_p);           // all note off 
    setup_voice(c_p, demosong[demo_no].inst[ch]); // initialize voice data
  } // for (ch = 0; ...
} // void init_seq()
#endif
